handler = (req, res) ->
	reply_err = (req, res, msg) ->
		res.writeHead(200, 'Content-Type': 'text/plain')
		return res.end("Error loading #{req.url} \"#{msg}\"")
	switch req.url
		when '/', '/index.html'
			filename = __dirname + '/index.html'
			type = 'text/html'
		when '/jquery.js'
			filename = '/usr/share/javascript/jquery/jquery.min.js'
			type = 'text/javascript'
		when '/terminal.js'
			filename = __dirname + '/terminal.coffee'
			type = 'text/javascript'
		else
			return reply_err req, res
	fs.readFile filename, 'utf8', (err, data) ->
		return reply_err req, res, err if err

		if filename.substr(filename.length - 7) is '.coffee'
			try
				data = coffee.compile data
			catch e
				return reply_err req, res, "server faild to compile #{filename}: #{JSON.stringify(e)}"

		res.writeHead(200, 'Content-Type': type)
		res.end(data)

coffee = require 'coffee-script'
app = require('http').createServer(handler)
io = require('socket.io').listen(app)
fs = require('fs')
terminal = require('./terminal.coffee')

# SETTINGS
app.listen(9293)
term = terminal.new(105, 66)

sockets = []

io.sockets.on 'connection', (socket) ->
	sockets.push socket
	socket.on 'disconnect', ->
		for i in [i...sockets.length]
			if sockets[i] is socket
				sockets.splice i, 1
				return

	socket.emit 'init', width: term.width, height: term.height, x: term.x, y: term.y, a: term.a, text: term.text, attributes: term.attributes

process.stdin.resume()
process.stdin.setEncoding 'utf8'

process.stdin.on 'data', (data) ->
	term.update data
	for s in sockets
		s.emit 'data', data

process.stdin.on 'end', -> process.exit()
